#!/bin/sh
# Common Ml ADmins server (CMAD)
#	Copyright 1998 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
#
VERSION=@VER@

#
# Set path of sendmail
#
SENDMAIL=@SENDMAIL@

#
# Set local environment.
#
DOMAIN=@DOMAIN@
ORGDOM=@DOMAIN@
DRIVER=@DRIVER@
PATH=@PATH@
AWK=@AWK@
GREP=@GREP@
MSPOOL=@MSPOOL@

export PATH
umask 022

unset LANG >/dev/null 2>&1

# Get PID
MYPID=$$

# Get name of Mailing List.
ML=$1

# Set work file.
MAIL=/tmp/MAIL.$$
HEAD=/tmp/HEAD.$$
BODY=/tmp/BODY.$$
TEMP=/tmp/TEMP.$$
SEND=/tmp/SEND.$$
SYSM=/tmp/SYSM.$$

LKEY=$DRIVER/$ML/.LOCK
LOCK=$DRIVER/$ML/.LOCK.lock
DGSTFILE=$MSPOOL/$ML/spool/.digest

PROFILE=$MSPOOL/$ML/profile
GCOSFILE=$MSPOOL/$ML/profile/.gcos

trap "rm -f $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 0 1 2 3 15

# Save Article.
cat > $MAIL

# Set default value.
. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# get error log?
if [ "$ERRORLOG" = "DO" ]
then
	LOGDIR=$DRIVER/$ML/LOGS
	if [ ! -d $LOGDIR ]
	then
		mkdir $LOGDIR
	fi
	CMADLOG=$LOGDIR/cmadlog.$$

	trap "rm -f $CMADLOG $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 0
	trap "rm -f $MAIL $HEAD $BODY $TEMP $SEND $SYSM $LOCK; exit 0" 1 2 3 15

	cat $MAIL > $CMADLOG
fi	

if [ "$GETADLOG" = "DO" ]
then
        LOGDIR=$DRIVER/$ML/LOGS
        if [ ! -d $LOGDIR ]
        then
                mkdir $LOGDIR
        fi
        ADLOG=$LOGDIR/cmadlog
fi

# Check change domain name.
if [ "$GENERICFROM" ]
then
	DOMAIN=$GENERICFROM
fi

# Admin list
ADLIST=$DRIVER/$ML/$ML-admins

# Member list
LIST=$DRIVER/$ML/$ML-member

# List of Post Only
POST=$DRIVER/$ML/$ML-postonly

# Deliver list
DELV=$DRIVER/$ML/$ML-list

if [ ! "$MESSAGES" ]
then
	MESSAGES=messages
fi

# Make unix-from address.
if [ ! "$UNIXFROM" ]
then
    UNIXFROM=$ML-request@$DOMAIN
fi

MYADDRESS=$ML-control@$DOMAIN

# Change old format
egrep -v "[0-9][0-9][0-9][0-9] <.*>" $ADLIST | \
        $AWK '{ printf("%s <%s>\n",$1,$2) }'   > ${ADLIST}.wk
egrep "[0-9][0-9][0-9][0-9] <.*>" $ADLIST >> ${ADLIST}.wk
mv ${ADLIST}.wk $ADLIST

# Get header
sed -n -e '1,/^$/p' < $MAIL > $HEAD

# Get body.
sed -e '1,/^$/d' < $MAIL > $BODY

# execute time.
TIME=`date | $AWK '{printf("%s %02d %s\n",$2,$3,$4)}' | sed -e 's/:..$//'`
TIME="[$TIME]"

# Check header.
FROM=`$AWK '
	BEGIN {rcv = 0;}
	/^$/, NR == 0 { next;}
	/^From / {next;}
	/^[Ff][Rr][Oo][Mm]:/ {rcv = 1; print; next;}
	/^[ 	]/ && rcv == 1 {print; next;}
	{rcv = 0};' < $HEAD | sed 's/[Ff][Rr][Oo][Mm]: //'`

set `echo $FROM | sed -e "s/(.*)//" -e "s/.*<//" -e "s/>.*//"` "ERROR"
FROM=$1

if [ "$GETADLOG" = "DO" ]
then
	echo "$TIME cmad start ($FROM)" >> $ADLOG
fi

if [ "$FROM" = "ERROR" ]
then
	exit 1
fi
ADDRESS=$FROM

echo $FROM | $GREP "@" >/dev/null 2>&1
if [ $? -ne 0 ]
then
        FROM="$FROM@$ORGDOM"
fi

ERROR=0
set `egrep -v '[*?[]' $BODY` .
ADMKEY=$1
ADMIN=`egrep "^$ADMKEY" $ADLIST`
if [ "$ADMIN" ]
then
	set $ADMIN . .

	echo $2 | grep -i $FROM >/dev/null 2>&1
	if [ $? -ne 0 ]
	then
		ERROR=1
	fi
else
	ERROR=1
fi

# check command

ADMC=`sed 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' < $BODY | 
	egrep "^admincmd"`

set $ADMC . ""
CMD=$2

SENDSUB="Admin command '$CMD' execute"
REPLYCONTROL=0
TOUSER=0
TOMEMB=0
CHANGE=0

if [ $ERROR -ne 0 ]
then
	CMD="error"
	if [ "$GETADLOG" = "DO" ]
	then
		echo "$TIME  -->keyword check failed." >> $ADLOG
	fi
else
	if [ "$GETADLOG" = "DO" ]
	then
		echo "$TIME  -->execute '$ADMC'" >> $ADLOG
	fi
fi

#
# get lock
#
case $CMD in
append|delete|address|send|stop|digest|admkey|postadd|postdel)
	# make lock key
	if [ ! -f $LKEY ]
	then
		touch $LKEY
	fi

	DELAY=`expr $MYPID % 6`

	# Get delay time.
	case "$DELAY" in
	0)	set 1 2 3 3 2 1 ;;
	1)	set 1 3 2 1 2 3 ;;
	2)	set 2 1 3 1 3 2 ;;
	3)	set 2 3 1 2 1 3 ;;
	4)	set 3 1 2 2 3 1 ;;
	*)	set 3 2 1 3 1 2 ;;
	esac

	umask 077
	until ln $LKEY $LOCK >/dev/null 2>&1
	do
		DELAY=$1
		shift
		set $@ $DELAY
		sleep $DELAY
	done
	# Lock comprele.
	umask 022
	;;
esac

#
# exec command
#
case $CMD in
admkey)
	ADDRESS=$FROM
	TOUSER=1
	echo "s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP
	sed -f $TEMP < $DRIVER/$MESSAGES/admkey > $SEND

	set $ADMC . . .
	PW=$3
 
	if [ "$PW" = "." ]
	then
		ERROR=2
	else
		KE=`echo 0000$PW | sed -e 's/.*\([0-9][0-9][0-9][0-9]\)$/\1/'`
		if [ "$PW" = "$KE" ]
		then
			echo "/^$ADMKEY <$FROM>/d
                              w
                              q
			" | ed >/dev/null 2>&1 $ADLIST
			echo "$PW <$FROM>"     >> $ADLIST
			echo ""                               >> $SEND
			echo "Admin Address:  $FROM"          >> $SEND
			echo "Change keyword: $ADMKEY -> $PW" >> $SEND
		else
			if [ "$GETADLOG" = "DO" ]
			then
				echo "$TIME  -->Keyword is not 4letters." >> $ADLOG
			fi
			ERROR=3
		fi
	fi
	rm -f $LOCK
	;;

getconfig)
	ADDRESS=$FROM
	TOUSER=1
	if [ -f $DRIVER/$ML/config.$ML ]
	then
		cat $DRIVER/$MESSAGES/getfile	>  $SEND
		cat $DRIVER/$ML/config.$ML	>> $SEND
	else
		cat $DRIVER/$MESSAGES/nofile	> $SEND
	fi
	;;

getoldconfig)
	ADDRESS=$FROM
	TOUSER=1
	if [ -f $DRIVER/$ML/config.$ML.old ]
	then
		cat $DRIVER/$MESSAGES/getfile	>  $SEND
		cat $DRIVER/$ML/config.$ML.old	>> $SEND
	else
		cat $DRIVER/$MESSAGES/nofile	>  $SEND
	fi
	;;

putconfig)
	ADDRESS=$FROM
	TOUSER=1
	sed -n -e '/^./,$p' < $BODY | \
	sed -n -e '1,/^[Aa][Dd][Mm][Ii][Nn][Cc][Mm][Dd]/d' -e '/^./,$p' > $TEMP

	/bin/sh $TEMP >/dev/null 2>&1

	if [ $? -eq 0 -a -s $TEMP ]
	then
		if [ -f $DRIVER/$ML/config.$ML ]
		then
			cat $DRIVER/$ML/config.$ML > $DRIVER/$ML/config.$ML.old
		fi
		cat $TEMP > $DRIVER/$ML/config.$ML
		cat $DRIVER/$MESSAGES/exfile	> $SEND
		cat $TEMP			>> $SEND
	else
		cat $DRIVER/$MESSAGES/exfile.err		    > $SEND
		sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
		cat $BODY					    >> $SEND
	fi
	;;

getinfo)
	ADDRESS=$FROM
	TOUSER=1
	if [ -f $DRIVER/$ML/info.$ML ]
	then
		cat $DRIVER/$MESSAGES/getfile	>  $SEND
		cat $DRIVER/$ML/info.$ML	>> $SEND
	else
		cat $DRIVER/$MESSAGES/nofile	>  $SEND
	fi
	;;

getoldinfo)
	ADDRESS=$FROM
	TOUSER=1
	if [ -f $DRIVER/$ML/info.$ML.old ]
	then
		cat $DRIVER/$MESSAGES/getfile	>  $SEND
		cat $DRIVER/$ML/info.$ML.old	>> $SEND
	else
		cat $DRIVER/$MESSAGES/nofile	>  $SEND
	fi
	;;

putinfo)
	ADDRESS=$FROM
	TOUSER=1
	sed -n -e '/^./,$p' < $BODY | \
	sed -n -e '1,/^[Aa][Dd][Mm][Ii][Nn][Cc][Mm][Dd]/d' -e '/^./,$p' > $TEMP

	if [ -s $TEMP ]
	then
		if [ -f $DRIVER/$ML/info.$ML ]
		then
			cat $DRIVER/$ML/info.$ML > $DRIVER/$ML/info.$ML.old
		fi
		cat $TEMP > $DRIVER/$ML/info.$ML
		cat $DRIVER/$MESSAGES/exfile	>  $SEND
		cat $TEMP			>> $SEND
	else
		cat $DRIVER/$MESSAGES/exfile.err		    >  $SEND
		sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD >> $SEND
		cat $BODY					    >> $SEND
	fi
	;;

append)
	set $ADMC . . .
	ADDRESS=$3
	if [ "$ADDRESS" = "." ]
	then
		ERROR=2
	else
		# Add user address to member list.
		if [ ! -f $LIST ]
		then
			if [ ! -d $DRIVER/$ML ]
			then
				mkdir $DRIVER/$ML
			fi
			NUM=0001
		else
			NUM=`sort -n $LIST | tail -1 | $AWK '{ print $1 }'`
			if [ ! "$NUM" ]
			then
				NUM=0
			fi
			NUM=`expr $NUM + 1`
			#NUM=`expr 000$NUM : '.*\(....\)$'`
			NUM=`echo 0000$NUM | sed -e  's/.*\(....\)$/\1/'`
		fi

		ID=`echo $ADDRESS | sed -e 's/@.*//'`
		#KEY=`expr 0000$$ : '.*\(....\)$'`
		KEY=`echo 0000$MYPID | sed -e 's/.*\(....\)$/\1/'`

		# Duplicate check.
		sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
			 $GREP -i "($ADDRESS)" >/dev/null 2>&1

		if [ $? -eq 0 ]
		then
			set `sed -e 's/</(/g' -e 's/>/)/g' < $LIST | \
				$GREP -i "($ADDRESS)"`

			NU=$1
			ST=$2
			AD=`echo $3 | \
			    sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
			PW=$4

			GC="`$GREP $NU $GCOSFILE | \
			     sed -e 's/^[0-9]* //' -e 's/[ 	]*$//' \
				 -e 's/\\\\/\\\\\\\\/g' \
				 -e 's/\\//\\\\\\//g'	\
				 -e 's/&/\\\\&/g'`"

			if [ "$GC" != "" ]
			then
				AD="$AD ($GC)"
			fi

			echo "s/%MlNaMe%/$ML@$DOMAIN/
			      s/%NuMbEe%/$NU/
			      s/%SMoDe%/$ST/
			      s/%KeYwOrD%/$PW/
			      s/%AdDrEsS%/$AD/" > $TEMP

			sed -f $TEMP < $DRIVER/$MESSAGES/duplicate  > $SEND

			PO="`$GREP $NU $POST`"
			if [ "$PO" != "" ]
			then
				echo ""				    >> $SEND
				cat $DRIVER/$MESSAGES/check-post    >> $SEND
				echo ""				    >> $SEND
				echo "$PO" | \
					$AWK '{printf("	%s\n",$2)}' >> $SEND
			fi

			ADDRESS=$FROM
			TOUSER=1

		else
			USERINFO="$NUM SEND <$ADDRESS> $KEY"
			SMODE="SEND"
			# check default digest
			if [ "$DGSTAPPEND" = "DO" ]
			then
				FROMDOM=`echo $ADDRESS |\
		                $AWK '{
		                        l = length($0);
		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
	               	        	}
					printf( "\n" );
		                }' | sed -e 's/@.*//' | \
		                $AWK '{
		                        l = length($0);
		                        for ( ; l > 0; l-- ) {
		                                printf("%s",substr($0, l, 1));
		                        }
		                        printf( "\n" );
		                }'`

				if [ -f $DRIVER/$ML/defaultdigest ]
				then
					for i in `cat $DRIVER/$ML/defaultdigest`
					do
						echo $FROMDOM | $GREP "$i" >/dev/null 2>&1
						if [ $? -eq 0 ]
						then
							USERINFO="$NUM DGST ($ADDRESS) $KEY <nobody>"
							SMODE="DGST"
						fi
					done
				fi
			fi
			echo $USERINFO >> $LIST
			CHANGE=1

			# Write user profile.
			if [ ! -d $PROFILE ]
			then
				mkdir $PROFILE
			fi

			sed -n -e '/^./,$p' < $BODY | \
			sed -n -e '1,/^[Aa][Dd][Mm][Ii][Nn][Cc][Mm][Dd]/d' \
			       -e '/^./,$p' > $TEMP

			if [ -s $TEMP ]
			then
				echo "<<Last Modified: `date`>>" >$PROFILE/$NUM
				cat $TEMP			>>$PROFILE/$NUM
			fi

			SEDADD=`echo $ADDRESS | sed  -e 's/\\\\/\\\\\\\\/g' \
						     -e 's/\\//\\\\\\//g'   \
						     -e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%kEyWd%/$KEY/
			      s/%AdMiN%/$ML-request@$DOMAIN/
			      s/%CNtLAdRs%/$MYADDRESS/
			      s/%MlNaMe%/$ML@$DOMAIN/
			      s/%mOdE%/$SMODE/" > $TEMP

			if [ "$USECHECK" != "DONT" ]
			then
				echo "s/^((//" >> $TEMP
			else
				echo "/^((/d" >> $TEMP
			fi

			if [ "$USEMEMBER" != "DONT" ]
			then
				echo "s/^))//" >> $TEMP
			else
				echo "/^))/d" >> $TEMP
			fi

			if [ "$ARCHIVE" = "DO" ]
			then
				if [ "$ACCESSFREE" = "DO" ]
				then
					echo "s/^&&//" >> $TEMP
					echo "/^%%/d"  >> $TEMP
				else
					echo "s/^%%//" >> $TEMP
					echo "/^&&/d"  >> $TEMP
				fi
			else
				echo "/^%%/d" >> $TEMP
				echo "/^&&/d" >> $TEMP
			fi

			sed -f $TEMP < $DRIVER/$MESSAGES/append >  $SEND

			if [ -f $DRIVER/$ML/info.$ML ]
			then
				echo "--<Information of $ML ML>----------" >> $SEND
				cat $DRIVER/$ML/info.$ML	>> $SEND
			fi

			sed -f $TEMP < $DRIVER/$MESSAGES/manual >> $SEND

			TOUSER=1

			AD="$ADDRESS"

			SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
						-e 's/\\//\\\\\\//g'   \
						-e 's/&/\\\\&/g'`

			echo "s/%NuMbEr%/$NUM/
			      s/%AdDrEsS%/$SEDADD/
			      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP
			sed -f $TEMP < $DRIVER/$MESSAGES/add	> $SYSM

			cat $PROFILE/$NUM		       >> $SYSM
			SYSSUB="Append member."
			TOMEMB=1
		fi
	fi
	rm -rf $LOCK
	;;

delete)
	set $ADMC . . .
	#NUM=`expr 0000$3 : '.*\(....\)$'`
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	MD=$2
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4

		ORGADRS=$AD

		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $GCOSFILE

		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $LIST
		echo "$NU QUIT () <nobody>" >> $LIST
		CHANGE=1

		if [ -f $POST ]
		then
			echo "g/^$NU /d
                              w
                              q
			" | ed >/dev/null 2>&1 $POST
		fi

		rm -f $PROFILE/$NU

		SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
					-e 's/\\//\\\\\\//g'   \
					-e 's/&/\\\\&/g'`

		echo "s/%NuMbEr%/$NUM/
		      s/%AdDrEsS%/$SEDADD/
		      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SYSM
		sed -f $TEMP < $DRIVER/$MESSAGES/delete > $SEND
		SYSSUB="Delete member."
		TOMEMB=1
		TOUSER=1
		rm -f $LOCK
	fi
	;;

address)
	set $ADMC . . .
	#NUM=`expr 0000$3 : '.*\(....\)$'`
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	AD=$4
	ORGADRS=$AD
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	MD=$2
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		OA=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4

		set `egrep "^$NU" $LIST` . .
		MODE=$2
		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $LIST

		if [ "$MODE" = "SEND" ]
		then
			UINFO="$NU SEND <$AD> $PW"
		else
			UINFO="$NU $MODE ($AD) $PW <nobody>"
		fi
		echo $UINFO >> $LIST
		CHANGE=1

		GC="`$GREP $NU $GCOSFILE | \
		     sed -e 's/^[0-9]* //' -e 's/[ 	]*$//' \
			 -e 's/\\\\/\\\\\\\\/g' \
			 -e 's/\\//\\\\\\//g'	\
			 -e 's/&/\\\\&/g'`"

		if [ "$GC" != "" ]
		then
			AD="$AD ($GC)"
		fi

		echo "s/%MlNaMe%/$ML@$DOMAIN/
		      s/%NuMbEe%/$NU/
		      s/%SMoDe%/$MODE/
		      s/%KeYwOrD%/$PW/
		      s/%AdDrEsS%/$AD/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/check	>  $SEND
		echo ""					>> $SEND
		cat $DRIVER/$MESSAGES/change		>> $SEND
		echo ""					>> $SEND
		echo "	$OA -> $AD" | sed -e 's/(.*)//'	>> $SEND

		PO="`$GREP $NU $POST`"
		if [ "$PO" != "" ]
		then
			echo ""				>> $SEND
			cat $DRIVER/$MESSAGES/check-post>> $SEND
			echo ""				>> $SEND
			echo "$PO" | \
				$AWK '{printf("	%s\n",$2)}'>>$SEND
		fi

		TOUSER=1

		rm -f $LOCK
	fi
	;;
postadd)
	echo "s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

	sed -f $TEMP < $DRIVER/$MESSAGES/postadd > $SEND

	set $ADMC . . .
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	AD=$4
	ORGADRS=$AD
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		grep "$NU <$AD>" $POST >/dev/null 2>&1
		if [ $? -eq 0 ]
		then
			sed -f $TEMP < $DRIVER/$MESSAGES/postdup > $SEND
		else
			echo "$NU <$AD>" >> $POST
		fi

		CHANGE=1

		echo "$AD" >> $SEND

		TOUSER=1

		rm -f $LOCK
	fi
	;;

postdel)
	echo "s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

	sed -f $TEMP < $DRIVER/$MESSAGES/postdel > $SEND

	set $ADMC . . .
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	AD=$4
	ORGADRS=$AD
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		egrep "^$NU <$AD>" $POST >/dev/null 2>&1
		if [ $? -ne 0 ]
		then
			ORGADRS=
			sed -f $TEMP < $DRIVER/$MESSAGES/postnon > $SEND
			else
			echo "/^$NU <$AD>/d
                              w
                              q
			" | ed >/dev/null 2>&1 $POST
		fi

		CHANGE=1
		echo "$AD" >> $SEND
		TOUSER=1
		rm -f $LOCK
	fi
	;;

send)
	set $ADMC . . .
	#NUM=`expr 0000$3 : '.*\(....\)$'`
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	MD=$2
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		NU=$1
		MD=$2
		AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4

		ORGADRS=$AD

		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $LIST
		echo "$NU SEND <$AD> $PW" >> $LIST
		CHANGE=1

		SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
					-e 's/\\//\\\\\\//g'   \
					-e 's/&/\\\\&/g'`

		echo "s/%NuMbEr%/$NUM/
		      s/%AdDrEsS%/$SEDADD/
		      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/send > $SYSM
		sed -f $TEMP < $DRIVER/$MESSAGES/send > $SEND
		TOUSER=1
		TOMEMB=1
		SYSSUB="Reregist member."
		if [ "$DLVMSG" != "DO" ]
		then
			AUTOMSG=DONT
		fi

		# Check digest spool.
		if [ "$MD" = "DGST" ]
		then
			cat $DGSTFILE				      >> $SEND
			echo ""					      >> $SEND
			echo "-------- End Digest of $ML ML --------" >> $SEND
		fi
	fi

	rm -f $LOCK
	;;

stop)
	set $ADMC . . .
	NUM=`expr 0000$3 : '.*\(....\)$'`
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	MD=$2
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4
		ORGADRS=$AD

		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $LIST
		echo "$NU STOP ($AD) $PW <nobody>" >> $LIST
		CHANGE=1

		SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
					-e 's/\\//\\\\\\//g'   \
					-e 's/&/\\\\&/g'`

		echo "s/%NuMbEr%/$NUM/
		      s/%AdDrEsS%/$SEDADD/
		      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SYSM
		sed -f $TEMP < $DRIVER/$MESSAGES/stop > $SEND
		SYSSUB="Stop member."
		TOMEMB=1
		TOUSER=1

		if [ "$DLVMSG" != "DO" ]
		then
			AUTOMSG=DONT
		fi

		# Check digest spool.
		if [ "$MD" = "DGST" ]
		then
			cat $DGSTFILE  >> $SEND
			echo ""        >> $SEND
			echo "-------- End Digest of $ML ML --------" >> $SEND
		fi
		echo ""      >> $SEND
	fi

	rm -f $LOCK
	;;

digest)
	set $ADMC . . .
	#NUM=`expr 0000$3 : '.*\(....\)$'`
	NUM=`echo 0000$3 | sed -e 's/.*\(....\)$/\1/'`
	set `egrep "^$NUM" $LIST` . .
	NU=$1
	MD=$2
	if [ "$NU" = "." ]
	then
		ERROR=2
	else
		AD=`echo $3 | sed -e "s/<//" -e "s/>//" -e "s/(//" -e "s/)//"`
		PW=$4

		ORGADRS=$AD

		echo "/^$NU /d
                      w
                      q
		" | ed >/dev/null 2>&1 $LIST
		echo "$NU DGST ($AD) $PW <nobody>" >> $LIST
		CHANGE=1

		if [ ! -f $DRIVER/$ML/batchtime ]
		then
			echo "03:00" > $DRIVER/$ML/batchtime
		fi

		SEDADD=`echo $AD | sed  -e 's/\\\\/\\\\\\\\/g' \
					-e 's/\\//\\\\\\//g'   \
					-e 's/&/\\\\&/g'`

		echo "s/%NuMbEr%/$NUM/
		      s/%AdDrEsS%/$SEDADD/
		      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

		sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SYSM
		cat $DRIVER/$ML/batchtime               >> $SYSM

		sed -f $TEMP < $DRIVER/$MESSAGES/digest  > $SEND
		cat $DRIVER/$ML/batchtime               >> $SEND

		SYSSUB="Send by digest style to $AD."
		TOUSER=1
		TOMEMB=1
		if [ "$DLVMSG" != "DO" ]
		then
			AUTOMSG=DONT
		fi
	fi
	rm -f $LOCK
	;;

getmemberlist)
	echo "***** Members list of $ML *****"     > $SEND
	echo "NUM  MODE  ADDRESS         KEYWORD" >> $SEND
	cat $DRIVER/$ML/$ML-member                >> $SEND

	if [ -f $POST ]
	then
		echo ""						>> $SEND
		echo "***** PostOnly Members list of $ML *****" >> $SEND
		echo "NUM  <ADDRESS>"				>> $SEND
		cat $POST					>> $SEND
	fi

        TOUSER=1
        TOMEMB=0
	;;
	
adminmanual)
	REPLYCONTROL=1
	echo "s/%CNtLAdRs%/$MYADDRESS/" > $TEMP
        sed -f $TEMP < $DRIVER/$MESSAGES/admmanual > $SEND

        TOUSER=1
        TOMEMB=0
	;;

manualto)
	REPLYCONTROL=1
	echo "s/%AdMiN%/$ML-request@$DOMAIN/
	      s/%CNtLAdRs%/$MYADDRESS/
	      s/%MlNaMe%/$ML@$DOMAIN/" > $TEMP

	if [ "$USECHECK" != "DONT" ]
	then
		echo "s/^((//" >> $TEMP
	else
		echo "/^((/d" >> $TEMP
	fi

	if [ "$USEMEMBER" != "DONT" ]
	then
		echo "s/^))//" >> $TEMP
	else
		echo "/^))/d" >> $TEMP
	fi

	if [ "$ARCHIVE" = "DO" ]
	then
		if [ "$ACCESSFREE" = "DO" ]
		then
			echo "s/^&&//" >> $TEMP
			echo "/^%%/d" >> $TEMP
		else
			echo "s/^%%//" >> $TEMP
			echo "/^&&/d" >> $TEMP
		fi
	else
		echo "/^%%/d" >> $TEMP
		echo "/^&&/d" >> $TEMP
	fi

	sed -f $TEMP < $DRIVER/$MESSAGES/help			 > $SEND

	if [ -f $DRIVER/$ML/info.$ML ]
	then
		echo "--<Information of $ML ML>----------"	>> $SEND
		cat $DRIVER/$ML/info.$ML			>> $SEND
	fi
	sed -f $TEMP < $DRIVER/$MESSAGES/manual			>> $SEND

	set $ADMC . . "ERROR"
	ADDRESS=$3

	if [ "$ADDRESS" = "ERROR" ]
	then
		ERROR=2
	fi	
	TOUSER=1
	;;

error)
	;;
*)
	ERROR=1
	if [ "$GETADLOG" = "DO" ]
	then
		echo "$TIME  -->command not support." >> $ADLOG
	fi
	;;

esac

if [ $ERROR -eq 1 ]
then
	echo "s/%CNtLAdRs%/$MYADDRESS/" > $TEMP

	cat $DRIVER/$MESSAGES/error				 > $SEND
	sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD	>> $SEND
	cat $BODY						>> $SEND
	sed -f $TEMP < $DRIVER/$MESSAGES/admmanual		>> $SEND

	SENDSUB="$SENDSUB error"
	ADDRESS=$FROM
	TOUSER=1
	TOMEMB=0

elif [ $ERROR -eq 2 ]
then
	if [ "$GETADLOG" = "DO" ]
	then
		echo "$TIME  -->syntax error detect." >> $ADLOG
	fi

	cat $DRIVER/$MESSAGES/error.exec			 > $SEND
	sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD	>> $SEND
	cat $BODY						>> $SEND
	echo ""							>> $SEND
	echo "***** Members list of $ML *****" 			>> $SEND
	echo "NUM  MODE  <ADDRESS> KEYWORD"			>> $SEND
	cat $LIST						>> $SEND

	if [ -f $POST ]
	then
		echo ""						>> $SEND
		echo "***** PostOnly Members list of $ML *****" >> $SEND
		echo "NUM  <ADDRESS>"				>> $SEND
		cat $POST					>> $SEND
	fi

	SENDSUB="$SENDSUB error"
	ADDRESS=$FROM
	TOUSER=1
	TOMEMB=0

elif [ $ERROR -eq 3 ]
then
	cat $DRIVER/$MESSAGES/error.exec2			 > $SEND
	sed -e 's/^[Ff][Rr][Oo][Mm][ 	]/\>From /' < $HEAD	>> $SEND
	cat $BODY						>> $SEND
	SENDSUB="$SENDSUB error"
	ADDRESS=$FROM
	TOUSER=1
	TOMEMB=0

fi

# mail send to user
if [ "$ORGADRS" = "." ]
then
	ORGADRS=
fi

if [ $TOUSER -eq 1 ]
then
	echo "To: $ADDRESS"			         > $HEAD
	if [ "$ORGADRS" != "" -a "$ADDRESS" != "$ORGADRS" ]
	then
		echo "Cc: $ORGADRS"                     >> $HEAD
	fi
	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SENDSUB."		        >> $HEAD
	echo "Errors-To: $ML-request@$DOMAIN"	        >> $HEAD
	echo "X-ML-Driver: CMAD (Version $VERSION)"     >> $HEAD

	if [ $REPLYCONTROL -eq 1 ]
	then
		echo "Reply-To: $ML-control@$DOMAIN"    >> $HEAD
	else
		echo "Reply-To: $ML-request@$DOMAIN"    >> $HEAD
	fi

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"			>> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""						>> $HEAD

	cat $HEAD $SEND | b64decode| $SENDMAIL -oi -t -f$UNIXFROM
fi

if [ $TOMEMB -eq 1 ]
then
	if [ "$AUTOMSG" = "DO" ]
	then
		echo "To: $ML@$DOMAIN"		         > $HEAD
	else
		echo "To: $ML-request@$DOMAIN"	         > $HEAD
	fi

	echo "From: $ML-request@$DOMAIN ($ML ML admin)" >> $HEAD
	echo "Subject: $SYSSUB"			        >> $HEAD

	if [ "$SENDER" ]
	then
		echo "Sender: $SENDER"		        >> $HEAD
	fi

	if [ "$PRECEDENCE" ]
	then
		echo "Precedence: $PRECEDENCE"		>> $HEAD
	fi
	echo ""					        >> $HEAD

	cat $HEAD $SYSM | b64decode | $SENDMAIL -oi -t -f$UNIXFROM
fi

#
# Make deliver list
#
if [ $CHANGE -eq 1 ]
then
	egrep "^[0-9]* SEND" $LIST | sed -e 's/.*<//' -e 's/>.*//' > $DELV

	if [ -f $DRIVER/$STATIC ]
	then
		cat /dev/null > $TEMP
		for i in `$AWK '{print $1}' < $DRIVER/$STATIC`
		do
			set `grep -i $i $DELV | sed -e 's/@/ /'` . .
			U=$1
			D=$2
			if [ "$U" != "." ]
			then
				set `grep -i $i $DRIVER/$STATIC`
				R=$2
				echo "s/@$D/%$D@$R/" >> $TEMP
			fi
		done

		if [ "`cat $TEMP`" != "" ]
		then
			sed -f $TEMP < $DELV > $TMP2
			cat $TMP2 > $DELV
		fi
	fi
fi

if [ -s $ADLOG ]
then
	chmod o-r $ADLOG
	chmod o-w $ADLOG
	chmod o-x $ADLOG
fi

exit 0
